Bug 55255 - Allow Body in HTTP DELETE method to support API that use it (like ElasticSearch)
Allow Body in HTTP DELETE method to support API that use it (like ElasticSearch)
Status: RESOLVED FIXED
Product: JMeter
Classification: Unclassified
Component: HTTP
2.9
All All
: P2 enhancement (vote)
: ---
Assigned To: JMeter issues mailing list
:
Depends on:
Blocks:
  Show dependency tree
 
Reported: 2013-07-12 10:53 UTC by immanuel.hayden
Modified: 2013-07-15 07:37 UTC (History)
1 user (show)



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description immanuel.hayden 2013-07-12 10:53:38 UTC
HI!

I have some API here that I would like to test which requires to pass along content as the body of a DELETE request. Sadly that doesn't work right now in JMeter it seems.

thx,
Imm
Comment 1 Philippe Mouawad 2013-07-12 11:43:05 UTC
As per http://tools.ietf.org/html/draft-ietf-httpbis-p2-semantics-19:

Bodies on DELETE requests have no defined semantics.  Note that
   sending a body on a DELETE request might cause some existing
   implementations to reject the request.



Other interesting links:
http://stackoverflow.com/questions/299628/is-an-entity-body-allowed-for-an-http-delete-request
Comment 2 immanuel.hayden 2013-07-12 11:59:46 UTC
I am aware of what is written in the specs (did quite some research on the topic myself, most specs simply dont mention it, the one you quoted just says "yes, you can do it, it does not have any fixed syntax from our side, and no guarantee it works with old implementations" (as in: sending a DELETE with body to a server that does not support it ... but who would want to do that anyhow).

The stackoverflow link also gives an example of an API other than the one I need to test that uses this, http://www.elasticsearch.org/guide/reference/api/delete-by-query/

So in general I think it should be allowed to set a body for DELETE requests, maybe to be considered together with 55256.
Comment 3 Philippe Mouawad 2013-07-12 12:04:56 UTC
fully agree with you, I put the specs and SO links for us as a reference.
Thanks for report.
Next time you can put a summary of your researches.
Comment 4 immanuel.hayden 2013-07-12 12:16:18 UTC
> Next time you can put a summary of your researches.
My bad, should have done that. Will remember for next time :)
Comment 5 Philippe Mouawad 2013-07-14 20:18:09 UTC
Date: Sun Jul 14 20:17:21 2013
New Revision: 1503047

URL: http://svn.apache.org/r1503047
Log:
Bug 55255 - Allow Body in HTTP DELETE method to support API that use it (like ElasticSearch)
Bugzilla Id: 55255

Modified:
    jmeter/trunk/src/protocol/http/org/apache/jmeter/protocol/http/sampler/HTTPHC3Impl.java
    jmeter/trunk/src/protocol/http/org/apache/jmeter/protocol/http/sampler/HTTPHC4Impl.java
    jmeter/trunk/src/protocol/http/org/apache/jmeter/protocol/http/sampler/HTTPSampleResult.java
    jmeter/trunk/xdocs/changes.xml
Comment 6 Philippe Mouawad 2013-07-14 20:19:51 UTC
Hello Immanuel,
Waiting for your feedback to mark issue as closed.

You can try with next nightly build (r1503047) that should be very close to 2.10 version.
Comment 7 Philippe Mouawad 2013-07-14 20:25:07 UTC
Note this is implemented in HC4 and HC31 implementations not in Java one.
Comment 8 immanuel.hayden 2013-07-15 07:37:11 UTC
Hi!

Seems to work. Thx for the awesomely fast response time :)

br,
Imm